Index: /trunk/src/objects/RpNumber.cc
===================================================================
--- /trunk/src/objects/RpNumber.cc	(revision 1559)
+++ /trunk/src/objects/RpNumber.cc	(revision 1560)
@@ -15,4 +15,7 @@
 #include "RpUnits.h"
 #include "RpSimpleBuffer.h"
+#include "RpUnitsCInterface.h"
+#include "RpParserXML.h"
+#include "RpPath.h"
 
 using namespace Rappture;
@@ -24,4 +27,6 @@
      _presets (NULL)
 {
+    // FIXME: empty names should be autoname'd
+    this->name("");
     this->path("");
     this->label("");
@@ -31,9 +36,9 @@
     this->min(0.0);
     this->max(0.0);
-    // need to set this to the None unit
+    // FIXME: empty units should be set to the None unit
     // this->units(units);
 }
 
-Number::Number(const char *path, const char *units, double val)
+Number::Number(const char *name, const char *units, double val)
    : Object (),
      _minSet (0),
@@ -43,5 +48,6 @@
     const RpUnits *u = NULL;
 
-    this->path(path);
+    this->name(name);
+    this->path("");
     this->label("");
     this->desc("");
@@ -58,5 +64,5 @@
 }
 
-Number::Number(const char *path, const char *units, double val,
+Number::Number(const char *name, const char *units, double val,
                double min, double max, const char *label,
                const char *desc)
@@ -68,5 +74,6 @@
     const RpUnits *u = NULL;
 
-    this->path(path);
+    this->name(name);
+    this->path("");
     this->label(label);
     this->desc(desc);
@@ -112,5 +119,5 @@
     this->units(o.units());
 
-    // need to copy _presets
+    // FIXME: need to copy _presets
 }
 
@@ -225,4 +232,30 @@
 
     return *this;
+}
+
+Number&
+Number::addPreset(const char *label, const char *desc, const char *val)
+{
+    double valval = 0.0;
+    const char *valunits = "";
+    char *endptr = NULL;
+    int result = 0;
+
+    std::string vstr = RpUnits::convert(val,"",RPUNITS_UNITS_OFF,&result);
+    if (result) {
+        // probably shouldnt trust this result
+        fprintf(stderr,"error in RpUnits::convert in addPreset\n");
+    }
+    size_t len = vstr.length();
+    valunits = val+len;
+
+    valval = strtod(val,&endptr);
+    if ( (endptr == val) || (endptr != valunits) ) {
+        // error? strtod was not able to find the same
+        // units location as RpUnits::convert
+        fprintf(stderr,"error while parsing units in addPreset\n");
+    }
+
+    return addPreset(label,desc,valval,valunits);
 }
 
@@ -276,33 +309,120 @@
 
 const char *
-Number::xml()
-{
+Number::xml(size_t indent, size_t tabstop)
+{
+    size_t l1width = indent + (1*tabstop);
+    size_t l2width = indent + (2*tabstop);
+    const char *sp = "";
+
     Path p(path());
     _tmpBuf.clear();
 
     _tmpBuf.appendf(
-"<number id='%s'>\n\
-    <about>\n\
-        <label>%s</label>\n\
-        <description>%s</description>\n\
-    </about>\n\
-    <units>%s</units>\n",
-       p.id(),label(),desc(),units());
+"%8$*5$s<number id='%1$s'>\n\
+%8$*6$s<about>\n\
+%8$*7$s<label>%2$s</label>\n\
+%8$*7$s<description>%3$s</description>\n\
+%8$*6$s</about>\n\
+%8$*6$s<units>%4$s</units>\n",
+       p.id(),label(),desc(),units(),indent,l1width,l2width,sp);
 
     if (_minSet) {
-        _tmpBuf.appendf("    <min>%g%s</min>\n", min(),units());
+        _tmpBuf.appendf("%4$*3$s<min>%1$g%2$s</min>\n", min(),units(),l1width,sp);
     }
     if (_maxSet) {
-        _tmpBuf.appendf("    <max>%g%s</max>\n", max(),units());
+        _tmpBuf.appendf("%4$*3$s<max>%1$g%2$s</max>\n", max(),units(),l1width,sp);
     }
 
     _tmpBuf.appendf(
-"    <default>%g%s</default>\n\
-    <current>%g%s</current>\n\
-</number>",
-       def(),units(),cur(),units());
+"%6$*5$s<default>%1$g%3$s</default>\n\
+%6$*5$s<current>%2$g%3$s</current>\n\
+%6$*4$s</number>",
+       def(),cur(),units(),indent,l1width,sp);
 
     return _tmpBuf.bytes();
 }
+
+/**********************************************************************/
+// METHOD: xml(const char *xmltext)
+/// configure the object based on Rappture1.1 xmltext
+/**
+ * Configure the object based on the provided xml
+ */
+
+void
+Number::xml(const char *xmltext)
+{
+    Rp_ParserXml *p = NULL;
+
+    p = Rp_ParserXmlCreate();
+
+    Rp_ParserXmlParse(p, xmltext);
+
+    Rp_TreeNode node = Rp_ParserXmlElement(p,NULL);
+    name(Rp_ParserXmlNodeId(p,node));
+    label(Rp_ParserXmlGet(p,"about.label"));
+    desc(Rp_ParserXmlGet(p,"about.description"));
+    units(Rp_ParserXmlGet(p,"units"));
+    minFromStr(Rp_ParserXmlGet(p,"min"));
+    maxFromStr(Rp_ParserXmlGet(p,"max"));
+    defFromStr(Rp_ParserXmlGet(p,"default"));
+    curFromStr(Rp_ParserXmlGet(p,"current"));
+
+    // collect info about the preset values
+    Rp_Chain *childChain = Rp_ChainCreate();
+    Rp_ParserXmlChildren(p,NULL,"preset",childChain);
+    Rp_ChainLink *l = Rp_ChainFirstLink(childChain);
+    while (l != NULL) {
+        Rp_TreeNode presetNode = (Rp_TreeNode) Rp_ChainGetValue(l);
+        Rp_ParserXmlBaseNode(p,presetNode);
+
+        const char *presetlabel = Rp_ParserXmlGet(p,"label");
+        const char *presetdesc = Rp_ParserXmlGet(p,"description");
+        const char *presetvalue = Rp_ParserXmlGet(p,"value");
+        addPreset(presetlabel,presetdesc,presetvalue);
+
+
+        l = Rp_ChainNextLink(l);
+    }
+
+    Rp_ChainDestroy(childChain);
+
+    // return the base node to the tree root
+    Rp_ParserXmlBaseNode(p,NULL);
+}
+
+/**********************************************************************/
+// METHOD: tree()
+/// return the object as a tree
+/**
+ * Represent the object as a tree.
+ * An Rp_TreeNode is returned.
+ */
+
+/*
+Rp_TreeNode
+tree()
+{
+    return NULL;
+}
+*/
+
+/**********************************************************************/
+// METHOD: tree(Rp_TreeNode root)
+/// construct a number object from the provided tree
+/**
+ * construct a number object from the provided tree
+ */
+
+/*
+void
+tree(
+    Rp_TreeNode root)
+{
+    if (root == NULL) {
+        // FIXME: setup error
+    }
+}
+*/
 
 /**********************************************************************/
@@ -321,4 +441,98 @@
 
 
+/**********************************************************************/
+// METHOD: minFromStr()
+/// xml helper function to receive min value as a string
+/**
+ * convert string to value and units and store as min
+ */
+
+void
+Number::minFromStr(
+    const char *val)
+{
+    double numericVal = 0;
+    int err = 0;
+
+    numericVal = rpConvertDbl(val,units(),&err);
+
+    if (!err) {
+        min(numericVal);
+    } else {
+        // FIXME: add error code
+    }
+}
+
+/**********************************************************************/
+// METHOD: maxFromStr()
+/// xml helper function to receive max value as a string
+/**
+ * convert string to value and units and store as max
+ */
+
+void
+Number::maxFromStr(
+    const char *val)
+{
+    double numericVal = 0;
+    int err = 0;
+
+    numericVal = rpConvertDbl(val,units(),&err);
+
+    if (!err) {
+        max(numericVal);
+    } else {
+        // FIXME: add error code
+    }
+}
+
+/**********************************************************************/
+// METHOD: defFromStr()
+/// xml helper function to receive default value as a string
+/**
+ * convert string to value and units and store as default
+ */
+
+void
+Number::defFromStr(
+    const char *val)
+{
+    double numericVal = 0;
+    int err = 0;
+
+    numericVal = rpConvertDbl(val,units(),&err);
+
+    if (!err) {
+        def(numericVal);
+    } else {
+        // FIXME: add error code
+    }
+}
+
+/**********************************************************************/
+// METHOD: currFromStr()
+/// xml helper function to receive current value as a string
+/**
+ * convert string to value and units and store as current
+ */
+
+void
+Number::curFromStr(
+    const char *val)
+{
+    double numericVal = 0;
+    int err = 0;
+
+    numericVal = rpConvertDbl(val,units(),&err);
+
+    if (!err) {
+        cur(numericVal);
+    } else {
+        // FIXME: add error code
+    }
+}
+
+
+
 // -------------------------------------------------------------------- //
 
Index: /trunk/src/objects/RpNumber.h
===================================================================
--- /trunk/src/objects/RpNumber.h	(revision 1559)
+++ /trunk/src/objects/RpNumber.h	(revision 1560)
@@ -22,7 +22,7 @@
 
         Number();
-        Number(const char *path, const char *units, double val);
+        Number(const char *name, const char *units, double val);
 
-        Number(const char *path, const char *units, double val,
+        Number(const char *name, const char *units, double val,
                double min, double max, const char *label,
                const char *desc);
@@ -52,8 +52,23 @@
                           double val, const char *units);
 
+        Number& addPreset(const char *label, const char *desc,
+                          const char *val);
+
         Number& delPreset(const char *label);
 
-        const char* xml();
+        const char* xml(size_t indent, size_t tabstop);
+        void xml(const char *xmltext);
+
+        /*
+        Rp_TreeNode tree();
+        void tree(Rp_TreeNode root);
+        */
+
         const int is() const;
+
+        void minFromStr(const char *val);
+        void maxFromStr(const char *val);
+        void defFromStr(const char *val);
+        void curFromStr(const char *val);
 
     private:
Index: /trunk/src/objects/RpObject.cc
===================================================================
--- /trunk/src/objects/RpObject.cc	(revision 1559)
+++ /trunk/src/objects/RpObject.cc	(revision 1560)
@@ -25,4 +25,5 @@
 
 Object::Object (
+    const char *name,
     const char *path,
     const char *label,
@@ -31,4 +32,5 @@
     const char *color   )
 {
+    this->name(name);
     this->path(path);
     this->label(label);
@@ -40,4 +42,5 @@
 Object::Object(const Object& o)
 {
+    name(o.name());
     path(o.path());
     label(o.label());
@@ -58,4 +61,16 @@
 
 const char*
+Object::name() const
+{
+    return propstr("name");
+}
+
+void
+Object::name(const char *p)
+{
+    propstr("name",p);
+}
+
+const char*
 Object::path() const
 {
@@ -201,8 +216,15 @@
     }
 
+    if (val == NULL) {
+        // no value provided, no value stored.
+        // FIXME: raise error.
+        return;
+    }
+
     // set the value
     // FIXME: this is suspect,
     // want to use void's and void*'s but c++ wont let me
     // g++ says there is no delete[] for void*
+    // FIXME: can probably just get the length and use property() fxn
     size_t l = strlen(val);
     str = new char[l+1];
@@ -276,5 +298,5 @@
 
 const char *
-Object::xml() const
+Object::xml(size_t indent, size_t tabstop) const
 {
     return NULL;
Index: /trunk/src/objects/RpObject.h
===================================================================
--- /trunk/src/objects/RpObject.h	(revision 1559)
+++ /trunk/src/objects/RpObject.h	(revision 1560)
@@ -24,5 +24,6 @@
     public:
         Object ();
-        Object (const char *path,
+        Object (const char *name,
+                const char *path,
                 const char *label,
                 const char *desc,
@@ -31,4 +32,7 @@
         Object (const Object& o);
         virtual ~Object();
+
+        const char *name(void) const;
+        void name(const char *p);
 
         const char *path(void) const;
@@ -45,5 +49,5 @@
 
         const char *color(void) const;
-        void color(const char *);
+        void color(const char *p);
 
         // void *icon(void) const;
@@ -66,5 +70,5 @@
 
         // get the Rappture1.1 xml text for this object
-        virtual const char *xml() const;
+        virtual const char *xml(size_t indent, size_t tabstop) const;
 
         // set the object properties based on Rappture1.1 xml text
Index: /trunk/src/objects/RpParserXML.cc
===================================================================
--- /trunk/src/objects/RpParserXML.cc	(revision 1560)
+++ /trunk/src/objects/RpParserXML.cc	(revision 1560)
@@ -0,0 +1,694 @@
+/*
+ * ----------------------------------------------------------------------
+ *  Rappture 2.0 XML Parser Object Source
+ *
+ * ======================================================================
+ *  AUTHOR:  Derrick Kearney, Purdue University
+ *  Copyright (c) 2005-2009  Purdue Research Foundation
+ *
+ *  See the file "license.terms" for information on usage and
+ *  redistribution of this file, and for a DISCLAIMER OF ALL WARRANTIES.
+ * ======================================================================
+ */
+
+#include "RpParserXML.h"
+#include "RpSimpleBuffer.h"
+#include "RpPath.h"
+
+static const char *Rp_ParserXml_Field_ID = "id";
+static const char *Rp_ParserXml_Field_VALUE = "value";
+static const char *Rp_ParserXml_Field_VISITED = "visited";
+
+struct Rp_ParserXmlStruct {
+    Rp_Tree tree;
+    Rp_TreeNode curr;
+    Rappture::Path *path;
+    Rappture::SimpleCharBuffer *buf;
+};
+
+
+static void XMLCALL
+Rp_ParserXmlStartHandler(
+    void *data,
+    const char *el,
+    const char **attr)
+{
+    Rp_ParserXml *inf = (Rp_ParserXml *) data;
+    size_t i = 0;
+
+    inf->curr = Rp_TreeCreateNode(inf->tree, inf->curr, el, -1);
+
+    // store the attributes in the node
+    while (attr[i] != NULL) {
+        const char *attrName = attr[i++];
+        size_t attrValueLen = strlen(attr[i]);
+        // FIXME: memory leak originating from this new call
+        // I'm not sure where/when the attrValue is deleted yet
+        char *attrValue = new char[attrValueLen+1];
+        strcpy(attrValue,attr[i++]);
+        Rp_TreeSetValue(inf->tree,inf->curr,attrName,(void *)attrValue);
+    }
+    inf->path->add(el);
+}
+
+static void XMLCALL
+Rp_ParserXmlEndHandler(
+    void *data,
+    const char *el)
+{
+    Rp_ParserXml *inf = (Rp_ParserXml *) data;
+
+    if (inf == NULL) {
+        return;
+    }
+
+    char *value = NULL;
+    Rp_TreeGetValue(inf->tree,inf->curr,Rp_ParserXml_Field_VALUE,(void **)&value);
+
+    // strip trailing spaces
+    int i = 0;
+    for (i = strlen(value)-1; i >= 0; i--) {
+        if (isspace(value[i])) {
+            value[i] = '\0';
+        } else {
+            break;
+        }
+    }
+
+    // strip leading spaces
+    int j = 0;
+    for (j = 0; j < i; j++) {
+        if (isspace(value[j])) {
+            value[j] = '\0';
+        } else {
+            break;
+        }
+    }
+
+    if (j > 0) {
+        // reallocate the trimmed string
+        char *newValue = new char[i-j+1+1];
+        strcpy(newValue,value+j);
+        Rp_TreeSetValue(inf->tree,inf->curr,Rp_ParserXml_Field_VALUE,(void *)newValue);
+        delete value;
+        value = NULL;
+    }
+
+    inf->path->del();
+    inf->curr = Rp_TreeNodeParent(inf->curr);
+}
+
+void
+Rp_ParserXmlDefaultCharHandler(
+    void* data,
+    XML_Char const* s,
+    int len)
+{
+    Rp_ParserXml *inf = (Rp_ParserXml *) data;
+
+    if (inf == NULL) {
+        return;
+    }
+
+    // FIXME: where/when is this deallocated
+    char *d = new char[len+1];
+
+    if ( s != NULL) {
+        strncpy(d,s,len);
+    }
+
+    d[len] = '\0';
+    Rp_TreeSetValue(inf->tree,inf->curr,Rp_ParserXml_Field_VALUE,(void *)d);
+}
+
+Rp_ParserXml *
+Rp_ParserXmlCreate()
+{
+    Rp_ParserXml *p = new Rp_ParserXml();
+
+    Rp_TreeCreate("rapptureTree",&(p->tree));
+    p->curr = Rp_TreeRootNode(p->tree);
+    p->path = new Rappture::Path();
+    p->buf = new Rappture::SimpleCharBuffer();
+
+
+    return p;
+}
+
+void
+Rp_ParserXmlDestroy(Rp_ParserXml **p)
+{
+    if (p == NULL) {
+        return;
+    }
+
+    if (*p == NULL) {
+        return;
+    }
+
+    Rp_TreeReleaseToken((*p)->tree);
+    delete (*p)->buf;
+    delete (*p)->path;
+    delete *p;
+    p = NULL;
+}
+
+void
+Rp_ParserXmlParse(
+    Rp_ParserXml *p,
+    const char *xml)
+{
+    if (xml == NULL) {
+        return;
+    }
+
+    XML_Parser parser = XML_ParserCreate(NULL);
+    XML_SetUserData(parser,p);
+    XML_SetElementHandler(parser, Rp_ParserXmlStartHandler,
+        Rp_ParserXmlEndHandler);
+    XML_SetDefaultHandlerExpand(parser, Rp_ParserXmlDefaultCharHandler);
+
+    int done = 1;
+    int len = 0;
+
+    len = strlen(xml);
+    if (XML_Parse(parser, xml, len, done) == XML_STATUS_ERROR) {
+        fprintf(stderr, "Parse error at line %lu:\n%s\n",
+                XML_GetCurrentLineNumber(parser),
+                XML_ErrorString(XML_GetErrorCode(parser)));
+        exit(-1);
+    }
+
+    XML_ParserFree(parser);
+
+    // reset the root node
+    p->curr = Rp_TreeFirstChild(Rp_TreeRootNode(p->tree));
+
+    return;
+}
+
+Rp_TreeNode
+Rp_ParserXmlCreateNode(
+    Rp_ParserXml *p,
+    Rp_TreeNode parent,
+    const char *type,
+    const char *id)
+{
+    if (!p->tree || !parent || !type) {
+        fprintf(stderr,"failed to create node because of invalid data\n");
+        return NULL;
+    }
+
+    Rp_TreeNode child = Rp_TreeCreateNode(p->tree, parent, type, -1);
+
+    if (id != NULL) {
+        size_t attrValueLen = strlen(id);
+        // FIXME: memory leak originating from this new call
+        // I'm not sure where/when the attrValue is deleted yet
+        char *attrValue = new char[attrValueLen+1];
+        strcpy(attrValue,id);
+        Rp_TreeSetValue(p->tree,child,Rp_ParserXml_Field_ID,(void *)attrValue);
+    }
+
+    return child;
+}
+
+Rp_TreeNode
+Rp_ParserXmlSearch(
+    Rp_ParserXml *p,
+    const char *path,
+    int create)
+{
+    Rappture::Path pathObj(path);
+    Rp_TreeNode parent = NULL;
+    Rp_TreeNode child = NULL;
+    size_t degree = 0;
+
+    if (p == NULL) {
+        return NULL;
+    }
+
+    // start searching from the base node
+    parent = p->curr;
+
+    // if (path == NULL) return the base node
+    child = p->curr;
+
+    pathObj.first();
+    while ( (!pathObj.eof()) &&
+            (parent != NULL) ) {
+
+        const char *childName = pathObj.type();
+        const char *searchChildId = pathObj.id();
+
+        child = Rp_TreeFindChild(parent,childName);
+        if (child == NULL) {
+            // no nodes with the name childName exist
+            // FIXME: use the RPXML_CREATE flag
+            if (create) {
+                for (size_t i = 1; i <= pathObj.degree(); i++) {
+                    child = Rp_ParserXmlCreateNode(p, parent,
+                                childName, searchChildId);
+                    if (child == NULL) {
+                        break;
+                    }
+                }
+            } else {
+                fprintf(stderr,"invalid path %s at %s\n",path,childName);
+                break;
+            }
+        }
+
+        //FIXME: rewrite the child id search logic
+        const char *id = NULL;
+        Rp_TreeGetValue(p->tree,child, Rp_ParserXml_Field_ID,(void **)&id);
+        while (searchChildId && id) {
+
+            // check for matching child id and degree
+            if ((*searchChildId == *id) &&
+                (strcmp(searchChildId,id) == 0)) {
+                // found child with matching id
+                // check degree
+                degree++;
+                if (degree == pathObj.degree()) {
+                    // degrees match, return result
+                    break;
+                }
+            }
+
+            // check the next child to see if it has the correct id
+            child = Rp_TreeNextSibling(child);
+            if (child == NULL) {
+                // end of the sibling list
+                // create new node? or return NULL pointer
+                // FIXME: use the RPXML_CREATE flag
+                if (create) {
+                    child = Rp_ParserXmlCreateNode(p, parent,
+                                childName, searchChildId);
+                    if (child == NULL) {
+                        break;
+                    }
+                } else {
+                    // exit, child not found
+                    break;
+                }
+            }
+            id = NULL;
+            Rp_TreeGetValue(p->tree,child,Rp_ParserXml_Field_ID,(void **)&id);
+        }
+
+        parent = child;
+        pathObj.next();
+    }
+
+    return child;
+}
+
+const char *
+Rp_ParserXmlGet(
+    Rp_ParserXml *p,
+    const char *path)
+{
+    const char *value = NULL;
+    Rp_TreeNode child = NULL;
+
+    child = Rp_ParserXmlSearch(p, path, 0);
+    if (child != NULL) {
+        Rp_TreeGetValue(p->tree,child,Rp_ParserXml_Field_VALUE,(void **)&value);
+    }
+
+    return value;
+}
+
+void
+Rp_ParserXmlPut(
+    Rp_ParserXml *p,
+    const char *path,
+    const char *val,
+    int append)
+{
+    const char *oldval = NULL;
+    char *newval = NULL;
+    size_t oldval_len = 0;
+    size_t val_len = 0;
+
+    if (val == NULL) {
+        // no value, do nothing
+        return;
+    }
+
+    Rp_TreeNode child = Rp_ParserXmlSearch(p, path, 1);
+
+    if (child != NULL) {
+        // check to see if there is already a value
+        if (RP_OK == Rp_TreeGetValue(p->tree,child,
+                        Rp_ParserXml_Field_VALUE,
+                        (void **)&oldval)) {
+            if (oldval != NULL) {
+                // FIXME: use the RPXML_APPEND flag
+                if (append) {
+                    oldval_len = strlen(oldval);
+                    val_len = strlen(val);
+                    newval = new char[oldval_len + val_len + 1];
+                    strncpy(newval,oldval,oldval_len);
+                }
+                // free the old data
+                delete(oldval);
+                oldval = NULL;
+            }
+        }
+
+        // allocate space for our new value if needed
+        if (newval == NULL) {
+            // set the new value for the node
+            val_len = strlen(val);
+            newval = new char[val_len + 1];
+        }
+
+        strcpy(newval+oldval_len,val);
+
+        // set the value of the child node
+        if (RP_ERROR == Rp_TreeSetValue(p->tree,child,
+                            Rp_ParserXml_Field_VALUE,
+                            (void *)newval)) {
+            fprintf(stderr,"error while setting value of %s\n",path);
+        }
+    }
+    return;
+}
+
+Rp_Tree
+Rp_ParserXmlTreeClient(
+    Rp_ParserXml *p)
+{
+    if (p == NULL) {
+        return NULL;
+    }
+    Rp_Tree newTree = NULL;
+    // create a new token for the tree and return it to the caller
+    Rp_TreeGetTokenFromToken(p->tree,&newTree);
+    return newTree;
+}
+
+int
+printXmlData(
+    Rp_TreeNode node,
+    ClientData clientData,
+    int order)
+{
+    Rp_ParserXml *p = (Rp_ParserXml *) clientData;
+
+    Rappture::Path labelComp(Rp_TreeNodeLabel(node));
+    const char *label = labelComp.type();
+    const char *value = NULL;
+
+    size_t width = (Rp_TreeNodeDepth(p->tree,node)-1)*PARSERXML_LEVEL_WIDTH;
+    const char *sp = "";
+    int *visited = NULL;
+
+    Rp_TreeGetValue(p->tree,node,Rp_ParserXml_Field_VALUE,(void **)&value);
+    size_t valLen = strlen(value);
+
+    if (!Rp_TreeValueExists(p->tree,node,Rp_ParserXml_Field_VISITED)) {
+        visited = new int();
+        *visited = 0;
+
+        p->buf->appendf("%3$*2$s<%1$s",label,width,sp);
+
+        // go through all attributes and place them in the tag
+        Rp_TreeKey attrName = NULL;
+        Rp_TreeKeySearch search;
+        attrName = Rp_TreeFirstKey (p->tree, node, &search);
+        while (attrName) {
+            if ((*Rp_ParserXml_Field_VALUE != *attrName) &&
+                (strcmp(Rp_ParserXml_Field_VALUE,attrName) != 0)) {
+                const char *attrValue = NULL;
+                Rp_TreeGetValueByKey(p->tree,node,attrName,(void**)&attrValue);
+                p->buf->appendf(" %s=\"%s\"",attrName,attrValue);
+            }
+            attrName = Rp_TreeNextKey(p->tree, &search);
+        }
+
+        // close the opening tag
+        p->buf->appendf(">");
+
+        // append the value of the tag if any
+        if ( (value != NULL ) &&
+             (valLen != 0) ) {
+            p->buf->appendf("%s",value);
+        } else {
+            p->buf->appendf("\n");
+        }
+
+        // set the "visited" temporary flag so the next time
+        // we encounter this node, we know it is as a closing node
+        Rp_TreeSetValue(p->tree,node,Rp_ParserXml_Field_VISITED,(void *)visited);
+
+    } else {
+        Rp_TreeGetValue(p->tree,node,Rp_ParserXml_Field_VISITED,(void **)&visited);
+        delete visited;
+        Rp_TreeUnsetValue(p->tree,node,Rp_ParserXml_Field_VISITED);
+        if ( (value != NULL ) &&
+             (valLen != 0) ) {
+            p->buf->appendf("</%s>\n",label);
+        } else {
+            p->buf->appendf("%3$*2$s</%1$s>\n",label,width,sp);
+        }
+
+    }
+
+    return RP_OK;
+}
+
+const char *
+Rp_ParserXmlXml(
+    Rp_ParserXml *p)
+{
+    p->buf->clear();
+    p->buf->appendf("<?xml version=\"1.0\"?>\n");
+
+    Rp_TreeNode root = p->curr;
+
+    Rp_TreeApplyDFS(root, printXmlData, (ClientData)p, TREE_PREORDER|TREE_POSTORDER);
+
+    return p->buf->bytes();
+}
+
+int
+printPathVal(
+    Rp_TreeNode node,
+    ClientData clientData,
+    int order)
+{
+    Rp_ParserXml *p = (Rp_ParserXml *) clientData;
+
+    int *visited = NULL;
+
+    if (!Rp_TreeValueExists(p->tree,node,Rp_ParserXml_Field_VISITED)) {
+        // update path
+        p->path->add(Rp_TreeNodeLabel(node));
+
+        const char *id = NULL;
+        if (RP_OK == Rp_TreeGetValue(p->tree,node,Rp_ParserXml_Field_ID,(void **)&id)) {
+            p->path->last();
+            p->path->id(id);
+        }
+
+        const char *value = NULL;
+        if (RP_ERROR == Rp_TreeGetValue(p->tree,node,Rp_ParserXml_Field_VALUE,(void **)&value)) {
+            // error while getting value, exit fxn gracefully?
+            // FIXME: add error code here
+        }
+
+        // append the path and value of the node to our result text
+        if (value && (strlen(value) != 0)) {
+            p->buf->appendf("%s %s\n",p->path->path(),value);
+        }
+
+        // set the "visited" temporary flag so the next time
+        // we encounter this node, we know it is as a closing node
+        visited = new int();
+        *visited = 0;
+        if (RP_ERROR == Rp_TreeSetValue(p->tree,node,Rp_ParserXml_Field_VISITED,(void *)visited)) {
+            // FIXME: error while setting value
+        }
+    } else {
+        // update path
+        p->path->del();
+
+        // delete the "visited" temporary flag from the node
+        if (RP_ERROR == Rp_TreeGetValue(p->tree,node,Rp_ParserXml_Field_VISITED,(void **)&visited)) {
+            // FIXME: error while getting value
+        }
+        delete visited;
+        if (RP_ERROR == Rp_TreeUnsetValue(p->tree,node,Rp_ParserXml_Field_VISITED)) {
+            // FIXME: error while unsetting value
+        }
+    }
+
+    return RP_OK;
+}
+
+const char *
+Rp_ParserXmlPathVal(
+    Rp_ParserXml *p)
+{
+    p->buf->clear();
+
+    // temporarily store p->path so we can use p as ClientData
+    Rappture::Path *tmpPath = p->path;
+    p->path = new Rappture::Path();
+
+    Rp_TreeNode root = p->curr;
+
+    Rp_TreeApplyDFS(root, printPathVal, (ClientData)p, TREE_PREORDER|TREE_POSTORDER);
+
+    // restore the original path
+    delete p->path;
+    p->path = tmpPath;
+
+    return p->buf->bytes();
+}
+
+Rp_TreeNode
+Rp_ParserXmlElement(
+    Rp_ParserXml *p,
+    const char *path)
+{
+    if (p == NULL) {
+        return NULL;
+    }
+
+    return Rp_ParserXmlSearch(p,path,!RPXML_CREATE);
+}
+
+Rp_TreeNode
+Rp_ParserXmlParent(
+    Rp_ParserXml *p,
+    const char *path)
+{
+    if (p == NULL) {
+        return NULL;
+    }
+
+    Rp_TreeNode node = Rp_ParserXmlSearch(p,path,!RPXML_CREATE);
+    if (node == NULL) {
+        return NULL;
+    }
+
+    return Rp_TreeNodeParent(node);
+}
+
+size_t
+Rp_ParserXmlChildren(
+    Rp_ParserXml *p,
+    const char *path,
+    const char *type,
+    Rp_Chain *children)
+{
+    size_t count = 0;
+
+    if (p == NULL) {
+        return count;
+    }
+
+    if (children == NULL) {
+        return count;
+    }
+
+    Rp_TreeNode node = Rp_ParserXmlSearch(p,path,!RPXML_CREATE);
+
+    if (node != NULL) {
+        node = Rp_TreeFindChild(node,type);
+        while (node != NULL) {
+            count++;
+            Rp_ChainAppend(children,(void*)node);
+            node = Rp_TreeFindChildNext(node,type);
+        }
+    }
+    return count;
+}
+
+size_t
+Rp_ParserXmlNumberChildren(
+    Rp_ParserXml *p,
+    const char *path,
+    const char *type)
+{
+    size_t count = 0;
+
+    if (p == NULL) {
+        return count;
+    }
+
+    Rp_TreeNode node = Rp_ParserXmlSearch(p,path,!RPXML_CREATE);
+    if (node != NULL) {
+        node = Rp_TreeFindChild(node,type);
+        while (node != NULL) {
+            count++;
+            node = Rp_TreeFindChildNext(node,type);
+        }
+    }
+
+    return count;
+}
+
+void
+Rp_ParserXmlBaseNode(
+    Rp_ParserXml *p,
+    Rp_TreeNode node)
+{
+    if (p != NULL) {
+        if (node == NULL) {
+            p->curr = Rp_TreeFirstChild(Rp_TreeRootNode(p->tree));
+        } else {
+            p->curr = node;
+        }
+    }
+}
+
+/*
+const char *
+Rp_ParserXmlNodePath(
+    Rp_ParserXml *p,
+    Rp_TreeNode node)
+{
+    Path pathObj("junk");
+
+    const char *type = NULL;
+    const char *id = NULL;
+
+    // FIXME: path's add and del don't work on the current node
+    if (p != NULL) {
+        while (node != p->curr) {
+            type = Rp_TreeNodeLabel(node)
+            Rp_TreeGetValue(p->tree,child, Rp_ParserXml_Field_ID,(void **)&id);
+            pathObj.first();
+            pathObj.add(type);
+            pathObj.id(id);
+            node = Rp_TreeNodeParent(node);
+        }
+    }
+
+    pathObj.first();
+    pathObj.del();
+    return path
+}
+*/
+
+const char *
+Rp_ParserXmlNodeId(
+    Rp_ParserXml *p,
+    Rp_TreeNode node)
+{
+    const char *id = NULL;
+    if (p != NULL) {
+        if (node != NULL) {
+            Rp_TreeGetValue(p->tree,node, Rp_ParserXml_Field_ID,(void **)&id);
+        }
+    }
+    return id;
+}
+
+// -------------------------------------------------------------------- //
+
